package com.oreilly.jent.jsf.library.validator;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

public class ISBNValidator implements Validator {

    public void validate(FacesContext facesContext,
                         UIComponent uiComponent, Object o)
                         throws ValidatorException {

        String val = o.toString();
        if (val != null) {
            if (val.length() == 10) {
              if(!checkISBN(val))
                  throwValidatorException("ISBN does not pass validation");
            } else {
                throwValidatorException("ISBN must be 10 characters");
            }
        }
    }

    private boolean checkISBN(String ISBN) {
        int sum = 0;
        for (int i = 0; i < 10; i++) {
            char current = ISBN.charAt(i);
            int num = 0;
            if (current == 'X')
                num = 10;
            else
                num = current;
            sum += (num * (10-i));
        }
        return (sum % 11 == 0);
    }

    private void throwValidatorException(String detail)
            throws ValidatorException {
        FacesMessage message = new FacesMessage();
        message.setSeverity(FacesMessage.SEVERITY_ERROR);
        message.setSummary("Invalid ISBN");
        message.setDetail(detail);
        throw new ValidatorException(message);
    }
}
